// FEMMed.h : main header file for the FEMMED application
//

#if !defined(AFX_FEMMED_H__187EEF77_7CEE_40B6_81B4_6441C29C77BA__INCLUDED_)
#define AFX_FEMMED_H__187EEF77_7CEE_40B6_81B4_6441C29C77BA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#include "FEMMedCObArray.h"
#include "FEMMedPreferencesDlg.h"
#include "SymbolStyle.h"

enum Indent { TWOSPACES, FOURSPACES, TAB };

/////////////////////////////////////////////////////////////////////////////
// CFEMMedApp:
// See FEMMed.cpp for the implementation of this class
//

class CFEMMedApp : public CWinApp
{
public:
	CFEMMedApp();
	~CFEMMedApp();

	// Format all views. Used if preferences changed.
	void FormatAllViews();

private:
	CString m_strFilename;       // Used to hold the filename of the INI file.
	CString m_strHeader;         // Hold the comments in the INI file header.
	CString m_strDefaultHeader;  // Used if the INI file cannot be opened.
	CString m_strDefaultLuaKeywords;
	CString m_strDefaultFEMMLuaFunctions;

	// INI file helper functions.
	void LoadINIFile();
	void SetStyleFromString(CSymbolStyle&, const CString);

	// Extract data from INI file.
	BOOL ExtractBOOL(CString, const CString);
	COLORREF ExtractClr(CString);
	::Indent ExtractEnum(CString, CString);

	// Write to INI file.
	void WriteBOOL(CStdioFile&, CString, const BOOL);
	void WriteCOLORREF(CStdioFile&, const COLORREF);
	void WriteFEMMedCObArray(CStdioFile&, const CFEMMedCObArray&);
	void WriteStyle(CStdioFile&, const CSymbolStyle&);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFEMMedApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	virtual BOOL OnOpenRecentFile(UINT nID);
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CFEMMedApp)
	afx_msg void OnAppAbout();
	afx_msg void OnPreferences();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FEMMED_H__187EEF77_7CEE_40B6_81B4_6441C29C77BA__INCLUDED_)
