// FEMMedAddFunctionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FEMMed.h"
#include "FEMMedAddEditFunctionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFEMMedAddEditFunctionDlg dialog


CFEMMedAddEditFunctionDlg::CFEMMedAddEditFunctionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFEMMedAddEditFunctionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFEMMedAddEditFunctionDlg)
	//}}AFX_DATA_INIT

	// Load the bitmaps for the dialog buttons.
	COLORMAP  colorMap;
	colorMap.from = RGB(128, 0, 128);  // Make background color "invisible".
	colorMap.to = ::GetSysColor(COLOR_3DFACE);

	bmArrowUp.LoadMappedBitmap(IDB_ARROW_UP, 0, &colorMap, 1);
	bmArrowDn.LoadMappedBitmap(IDB_ARROW_DN, 0, &colorMap, 1);
}


void CFEMMedAddEditFunctionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFEMMedAddEditFunctionDlg)
	DDX_Control(pDX, IDC_BUTTONMOVEDOWN, c_buttonMoveDn);
	DDX_Control(pDX, IDC_BUTTONMOVEUP, c_buttonMoveUp);
	DDX_Control(pDX, IDC_BUTTONREMOVEFEMMLUAFUNCTIONPARAM, c_buttonRemoveFEMMLuaFunctionParam);
	DDX_Control(pDX, IDC_BUTTONADDFEMMLUAFUNCTIONPARAM, c_buttonAddFEMMLuaFunctionParam);
	DDX_Control(pDX, IDC_LISTFEMMLUAFUNCTIONPARAMS, c_listFEMMLuaFunctionParams);
	DDX_Control(pDX, IDC_EDITFEMMLUAFUNCTIONPARAM, c_editFEMMLuaFunctionParam);
	DDX_Control(pDX, IDC_EDITFEMMLUAFUNCTIONNAME, c_editFEMMLuaFunctionName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFEMMedAddEditFunctionDlg, CDialog)
	//{{AFX_MSG_MAP(CFEMMedAddEditFunctionDlg)
	ON_BN_CLICKED(IDC_BUTTONADDFEMMLUAFUNCTIONPARAM, OnAddFEMMLuaFunctionParam)
	ON_BN_CLICKED(IDC_BUTTONREMOVEFEMMLUAFUNCTIONPARAM, OnRemoveFEMMLuaFunctionParam)
	ON_EN_CHANGE(IDC_EDITFEMMLUAFUNCTIONPARAM, OnChangeEditFEMMLuaFunctionParam)
	ON_BN_CLICKED(IDC_BUTTONMOVEUP, OnMoveUp)
	ON_BN_CLICKED(IDC_BUTTONMOVEDOWN, OnMoveDown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFEMMedAddEditFunctionDlg message handlers

BOOL CFEMMedAddEditFunctionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Set focus to FEMM Lua function name.
	c_editFEMMLuaFunctionName.SetFocus();

	// Add images to buttons.
	c_buttonMoveUp.SetBitmap(bmArrowUp);
	c_buttonMoveDn.SetBitmap(bmArrowDn);

	// Populate list box with parameters.
	for(int i=0; i<m_pSA->GetSize(); i++)
	{
		if(i == 0)
		{
			c_editFEMMLuaFunctionName.SetWindowText(m_pSA->GetAt(i));
			int nEnd = c_editFEMMLuaFunctionName.GetWindowTextLength();
			c_editFEMMLuaFunctionName.SetSel(nEnd, nEnd);
		}
		else
		{
			c_listFEMMLuaFunctionParams.AddString(m_pSA->GetAt(i));
		}
	}

	if(c_listFEMMLuaFunctionParams.GetCount() == 0)
	{
		c_buttonRemoveFEMMLuaFunctionParam.EnableWindow(FALSE);
	}
	else
	{
		c_listFEMMLuaFunctionParams.SetCurSel(0);
	}

	// Add ToolTip.
	m_ttAddEditToolTip.Create(this);
	m_ttAddEditToolTip.AddWindowTool(GetDlgItem(IDC_BUTTONMOVEUP), \
		MAKEINTRESOURCE(IDSTT_MOVEPARAMUP));
	m_ttAddEditToolTip.AddWindowTool(GetDlgItem(IDC_BUTTONMOVEDN), \
		MAKEINTRESOURCE(IDSTT_MOVEPARAMDN));
	
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CFEMMedAddEditFunctionDlg::PreTranslateMessage(MSG* pMsg)
{
	// Don't allow non-alphanumeric characters in edit boxes.
	if(pMsg->message == WM_CHAR)
	{
		if(pMsg->hwnd == c_editFEMMLuaFunctionParam.GetSafeHwnd())
		{
			if((!isalpha(pMsg->wParam) && !isdigit(pMsg->wParam)) && pMsg->wParam != VK_BACK
				&& pMsg->wParam != '\"' && pMsg->wParam != '_')
				return TRUE;  // Don't dispatch message.
			if(pMsg->wParam == VK_RETURN)
				OnAddFEMMLuaFunctionParam();
		}
		else if(pMsg->hwnd == c_editFEMMLuaFunctionName.GetSafeHwnd())
		{
			if((!isalpha(pMsg->wParam) && !isdigit(pMsg->wParam)) && pMsg->wParam != VK_BACK
				&& pMsg->wParam != '_')
				return TRUE;  // Don't dispatch message.
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

// Add a parameter to the list box.
void CFEMMedAddEditFunctionDlg::OnAddFEMMLuaFunctionParam() 
{
	CString strParam;
	int nLen = c_editFEMMLuaFunctionParam.GetWindowText(strParam.GetBuffer(256), 256);
	strParam.ReleaseBuffer(nLen);

	c_listFEMMLuaFunctionParams.AddString(strParam);
	c_editFEMMLuaFunctionParam.SetWindowText("");
	c_listFEMMLuaFunctionParams.SetCurSel(c_listFEMMLuaFunctionParams.GetCount()-1);
	c_editFEMMLuaFunctionParam.SetFocus();
	c_buttonRemoveFEMMLuaFunctionParam.EnableWindow(TRUE);

	(*m_pnDelta)++;
}

void CFEMMedAddEditFunctionDlg::OnChangeEditFEMMLuaFunctionParam() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// Respond to key presses in the edit control.
	CString str;
	int nLen = c_editFEMMLuaFunctionParam.GetWindowText(str.GetBuffer(256), 256);
	str.ReleaseBuffer(nLen);

	if(str.GetLength() == 0)
		c_buttonAddFEMMLuaFunctionParam.EnableWindow(FALSE);
	else
		c_buttonAddFEMMLuaFunctionParam.EnableWindow(TRUE);
}

// Remove a parameter from the list box.
void CFEMMedAddEditFunctionDlg::OnRemoveFEMMLuaFunctionParam() 
{
	if(c_listFEMMLuaFunctionParams.GetCurSel() == LB_ERR)
		return;

	int nItem = c_listFEMMLuaFunctionParams.GetCurSel();
	if(nItem >= 0)
	{
		c_listFEMMLuaFunctionParams.DeleteString(nItem);
		if(c_listFEMMLuaFunctionParams.GetCount() > nItem)
		{
			c_listFEMMLuaFunctionParams.SetCurSel(nItem);
		}
		else if(c_listFEMMLuaFunctionParams.GetCount() > 0)
		{
			c_listFEMMLuaFunctionParams.SetCurSel(c_listFEMMLuaFunctionParams.GetCount()-1);
		}
		else
		{
			c_buttonRemoveFEMMLuaFunctionParam.EnableWindow(FALSE);
		}
	}

	(*m_pnDelta)--;
}

// Move a parameter up the list box.
void CFEMMedAddEditFunctionDlg::OnMoveUp() 
{
	int nCurSel = c_listFEMMLuaFunctionParams.GetCurSel();

	// Is item already top of list?
	if(nCurSel == 0 || nCurSel == LB_ERR)
		return;

	CString str;
	c_listFEMMLuaFunctionParams.GetText(nCurSel, str);
	c_listFEMMLuaFunctionParams.DeleteString(nCurSel);
	c_listFEMMLuaFunctionParams.InsertString(nCurSel-1, str);
	c_listFEMMLuaFunctionParams.SetCurSel(nCurSel-1);
}

// Move a parameter down the list box.
void CFEMMedAddEditFunctionDlg::OnMoveDown() 
{
	int nCurSel = c_listFEMMLuaFunctionParams.GetCurSel();

	// Is item already bottom of list?
	if(nCurSel == c_listFEMMLuaFunctionParams.GetCount()-1 || nCurSel == LB_ERR)
		return;

	CString str;
	c_listFEMMLuaFunctionParams.GetText(nCurSel, str);
	c_listFEMMLuaFunctionParams.DeleteString(nCurSel);
	c_listFEMMLuaFunctionParams.InsertString(nCurSel+1, str);
	c_listFEMMLuaFunctionParams.SetCurSel(nCurSel+1);
}

void CFEMMedAddEditFunctionDlg::OnOK() 
{
	// Check that a function name has been entered.
	CString strName;
	int nLen = c_editFEMMLuaFunctionName.GetWindowText(strName.GetBuffer(256), 256);
	strName.ReleaseBuffer(nLen);

	if(strName.IsEmpty())
	{
		MessageBox("A function name must be entered.", "FEMMed - Error!", \
			MB_ICONWARNING | MB_OK);
		c_editFEMMLuaFunctionName.SetFocus();
		return;
	}
	if(strName.FindOneOf("01234567890") == 0)
	{
		MessageBox("Function name cannot begin with a number.", "FEMMed - Error!", \
			MB_ICONWARNING | MB_OK);
		c_editFEMMLuaFunctionName.SetFocus();
		c_editFEMMLuaFunctionName.SetSel(0, -1);
		return;
	}

	// Empty the string array.
	m_pSA->RemoveAll();

	// Add function name to string array.
	m_pSA->Add(strName);

	// Add parameters.
	CString strParam;
	for(int i=0; i<c_listFEMMLuaFunctionParams.GetCount(); i++)
	{
		c_listFEMMLuaFunctionParams.GetText(i, strParam);
		m_pSA->Add(strParam);
	}
	
	CDialog::OnOK();
}