// FEMMedDoc.cpp : implementation of the CFEMMedDoc class
//

#include "stdafx.h"
#include "FEMMed.h"

#include "FEMMedDoc.h"
#include "CntrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Globals - see FEMMed.h and FEMMed.cpp.
extern int g_nUntitledCount;

/////////////////////////////////////////////////////////////////////////////
// CFEMMedDoc

IMPLEMENT_DYNCREATE(CFEMMedDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP(CFEMMedDoc, CRichEditDoc)
	//{{AFX_MSG_MAP(CFEMMedDoc)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_COMMAND(ID_FILE_SAVE_ALL, OnFileSaveAll)
	//}}AFX_MSG_MAP
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, CRichEditDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, CRichEditDoc::OnEditLinks)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFEMMedDoc construction/destruction

CFEMMedDoc::CFEMMedDoc()
{
	// Turn off rich text formatting tags.
	m_bRTF = FALSE;
}

CFEMMedDoc::~CFEMMedDoc()
{
}

BOOL CFEMMedDoc::OnNewDocument()
{
	if (!CRichEditDoc::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	m_strPathName = GetTitle();  // Used so that filename in SaveAs is correct.

	return TRUE;
}

CRichEditCntrItem* CFEMMedDoc::CreateClientItem(REOBJECT* preo) const
{
	// cast away constness of this
	return new CFEMMedCntrItem(preo, (CFEMMedDoc*) this);
}



/////////////////////////////////////////////////////////////////////////////
// CFEMMedDoc serialization

void CFEMMedDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}

	// Calling the base class CRichEditDoc enables serialization
	//  of the container document's COleClientItem objects.
	// TODO: set CRichEditDoc::m_bRTF = FALSE if you are serializing as text
	CRichEditDoc::Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CFEMMedDoc diagnostics

#ifdef _DEBUG
void CFEMMedDoc::AssertValid() const
{
	CRichEditDoc::AssertValid();
}

void CFEMMedDoc::Dump(CDumpContext& dc) const
{
	CRichEditDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFEMMedDoc commands

void CFEMMedDoc::SetTitle(LPCTSTR lpszTitle) 
{
	// TODO: Add your specialized code here and/or call the base class
	CString	str = lpszTitle;

	if(str.Right(4) != ".lua")
	{
		if(::g_nUntitledCount != 0)
		{
			str.Format("untitled[%i].lua", ::g_nUntitledCount);
		}
		else
		{
			str.Format("untitled.lua");
		}
		::g_nUntitledCount++;
	}
	
	CRichEditDoc::SetTitle((LPCTSTR)str);
}

void CFEMMedDoc::OnFileClose() 
{
	// Ensure there is always at least one view open.
	if(AfxGetApp()->GetOpenDocumentCount() == 1)
	{
		if(IsModified())
		{
			CString strMes = "Save changes to " + GetTitle() + "?";
			int nRes = MessageBox(this->GetView()->GetSafeHwnd(), strMes, "FEMMed",
				MB_YESNOCANCEL | MB_ICONWARNING);
			if(nRes == IDCANCEL)
				return;
			if(nRes == IDYES)
			{
				CRichEditDoc::OnFileSave();
			}
			if(nRes == IDNO)
			{
			}
			GetView()->SetWindowText("");
			SetTitle("");  // kludge to set new title
			SetModifiedFlag(FALSE);

			return;
		}
		else
		{
			CString str = "";
			GetView()->GetWindowText(str);
			if(str != "")
			{
				GetView()->SetWindowText("");
				SetTitle("");  // kludge to set new title
			}

			return;
		}
	}

	CRichEditDoc::OnFileClose();
}

// Save all open documents.
void CFEMMedDoc::OnFileSaveAll()
{
	((CFEMMedApp*)AfxGetApp())->SaveAllModified();
}