// FEMMedPreferencesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FEMMed.h"
#include "FEMMedPreferencesDlg.h"
#include "FEMMedAddEditFunctionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Globals - see FEMMed.h and FEMMed.cpp.
extern BOOL g_bAutoCompletion;
extern BOOL g_bAutoIndentation;
extern BOOL g_bIntelliTip;
extern BOOL g_bSyntaxHighlighting;
extern Indent g_enumIndent;
extern CFEMMedCObArray g_FEMMLuaFunctions;
extern CFEMMedCObArray g_LuaKeywords;
extern CSymbolStyle g_symComment;
extern CSymbolStyle g_symFunction;
extern CSymbolStyle g_symKeyword;
extern CSymbolStyle g_symNumber;
extern CSymbolStyle g_symPunctuation;
extern CSymbolStyle g_symString;

/////////////////////////////////////////////////////////////////////////////
// CFEMMedPreferencesDlg dialog

CFEMMedPreferencesDlg::CFEMMedPreferencesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFEMMedPreferencesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFEMMedPreferencesDlg)
	//}}AFX_DATA_INIT
	m_bLuaKeywordsChanged = m_bFEMMLuaFunctionsChanged = FALSE;
}


void CFEMMedPreferencesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFEMMedPreferencesDlg)
	DDX_Control(pDX, IDC_BUTTONEDITFEMMLUAFUNCTION, c_buttonEditFEMMLuaFunction);
	DDX_Control(pDX, IDC_BUTTONADDFEMMLUAFUNCTION, c_buttonAddFEMMLuaFunction);
	DDX_Control(pDX, IDC_BUTTONREMOVEFEMMLUAFUNCTION, c_buttonRemoveFEMMLuaFunction);
	DDX_Control(pDX, IDC_EDITLUAKEYWORD, c_editLuaKeyword);
	DDX_Control(pDX, IDC_BUTTONREMOVELUAKEYWORD, c_buttonRemoveLuaKeyword);
	DDX_Control(pDX, IDC_BUTTONADDLUAKEYWORD, c_buttonAddLuaKeyword);
	DDX_Control(pDX, IDC_LISTKEYWORDS, c_listLuaKeywords);
	DDX_Control(pDX, IDC_LISTFEMMLUAFUNCTIONS, c_listFEMMLuaFunctions);
	DDX_Control(pDX, IDC_CHECKINDENT, c_checkIndent);
	DDX_Control(pDX, IDC_CHECKOUTDENT, c_checkOutdent);
	DDX_Control(pDX, IDC_COMBOSTYLES, c_comboStyles);
	DDX_Control(pDX, IDC_SAMPLETEXT, c_sampleText);
	DDX_Control(pDX, IDC_RICHEDITCOLOR, c_richeditColor);
	DDX_Control(pDX, IDC_CHECKITALIC, c_checkItalic);
	DDX_Control(pDX, IDC_CHECKUNDERLINE, c_checkUnderline);
	DDX_Control(pDX, IDC_CHECKBOLD, c_checkBold);
	DDX_Control(pDX, IDC_BUTTONCOLOR, c_buttonColor);
	DDX_Control(pDX, IDC_CHECKINTELLITIP, c_checkIntelliTip);
	DDX_Control(pDX, IDC_BUTTONAPPLY, c_buttonApply);
	DDX_Control(pDX, IDC_RADIOFOURSPACES, c_radioFourSpaces);
	DDX_Control(pDX, IDC_RADIOTAB, c_radioTab);
	DDX_Control(pDX, IDC_RADIOTWOSPACES, c_radioTwoSpaces);
	DDX_Control(pDX, IDC_CHECKSYNTAXHIGHLIGHTING, c_checkSyntaxHighlighting);
	DDX_Control(pDX, IDC_CHECKAUTOINDENTATION, c_checkAutoIndentation);
	DDX_Control(pDX, IDC_CHECKAUTOCOMPLETION, c_checkAutoCompletion);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFEMMedPreferencesDlg, CDialog)
	//{{AFX_MSG_MAP(CFEMMedPreferencesDlg)
	ON_BN_CLICKED(IDC_BUTTONAPPLY, OnApply)
	ON_BN_CLICKED(IDC_CHECKAUTOCOMPLETION, OnAutoCompletion)
	ON_BN_CLICKED(IDC_CHECKAUTOINDENTATION, OnAutoIndentation)
	ON_BN_CLICKED(IDC_CHECKINTELLITIP, OnIntelliTip)
	ON_BN_CLICKED(IDC_CHECKSYNTAXHIGHLIGHTING, OnSyntaxHighlighting)
	ON_CBN_SELCHANGE(IDC_COMBOSTYLES, OnSelchangeComboStyles)
	ON_BN_CLICKED(IDC_BUTTONCOLOR, OnColor)
	ON_BN_CLICKED(IDC_CHECKBOLD, OnBold)
	ON_BN_CLICKED(IDC_CHECKITALIC, OnItalic)
	ON_BN_CLICKED(IDC_CHECKUNDERLINE, OnUnderline)
	ON_LBN_SELCHANGE(IDC_LISTKEYWORDS, OnSelChangeListKeywords)
	ON_BN_CLICKED(IDC_BUTTONADDLUAKEYWORD, OnAddLuaKeyword)
	ON_EN_CHANGE(IDC_EDITLUAKEYWORD, OnChangeEditLuaKeyword)
	ON_BN_CLICKED(IDC_BUTTONREMOVELUAKEYWORD, OnRemoveLuaKeyword)
	ON_BN_CLICKED(IDC_CHECKINDENT, OnIndent)
	ON_BN_CLICKED(IDC_CHECKOUTDENT, OnOutdent)
	ON_BN_CLICKED(IDC_BUTTONADDFEMMLUAFUNCTION, OnAddFEMMLuaFunction)
	ON_BN_CLICKED(IDC_BUTTONEDITFEMMLUAFUNCTION, OnEditFEMMLuaFunction)
	ON_BN_CLICKED(IDC_BUTTONREMOVEFEMMLUAFUNCTION, OnRemoveFEMMLuaFunction)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFEMMedPreferencesDlg message handlers

BOOL CFEMMedPreferencesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Disable Apply button and set focus to first item.
	c_buttonApply.EnableWindow(FALSE);
	c_checkAutoCompletion.SetFocus();

	// Set symbol styles.
	m_symStyles[0] = ::g_symComment;
	m_symStyles[1] = ::g_symFunction;
	m_symStyles[2] = ::g_symKeyword;
	m_symStyles[3] = ::g_symNumber;
	m_symStyles[4] = ::g_symPunctuation;
	m_symStyles[5] = ::g_symString;
	
	// Features.
	c_checkAutoCompletion.SetCheck(::g_bAutoCompletion);
	c_checkAutoIndentation.SetCheck(::g_bAutoIndentation);
	c_checkIntelliTip.SetCheck(::g_bIntelliTip);
	c_checkSyntaxHighlighting.SetCheck(::g_bSyntaxHighlighting);

	switch(g_enumIndent)
	{
	case ::TAB:
		c_radioTab.SetCheck(1);
		break;
	case ::FOURSPACES:
		c_radioFourSpaces.SetCheck(1);
		break;
	case ::TWOSPACES:
		c_radioTwoSpaces.SetCheck(1);
		break;
	}
	
	// Styles.
	c_comboStyles.SetCurSel(0);
	c_richeditColor.SetBackgroundColor(FALSE, m_symStyles[0].GetColor());
	c_checkBold.SetCheck(m_symStyles[0].GetBold());
	c_checkItalic.SetCheck(m_symStyles[0].GetItalic());
	c_checkUnderline.SetCheck(m_symStyles[0].GetUnderline());
	c_sampleText.SetFontName("Arial");
	c_sampleText.SetFontSize(12);
	c_sampleText.SetTextColor(m_symStyles[0].GetColor());
	c_sampleText.SetFontBold(m_symStyles[0].GetBold());
	c_sampleText.SetFontItalic(m_symStyles[0].GetItalic());
	c_sampleText.SetFontUnderline(m_symStyles[0].GetUnderline());

	// Lua keywords.
	for(int i=0; i<::g_LuaKeywords.GetSize(); i++)  // Add to listbox.
	{
		c_listLuaKeywords.AddString(((CStringArray*)::g_LuaKeywords.GetAt(i))->GetAt(0));
	}

	CStringArray* pSA;

	if(::g_LuaKeywords.GetSize() > 0)
	{
		pSA = (CStringArray*)::g_LuaKeywords.GetAt(0);  // Set checks.
		CString str;
		for(i=1; i<pSA->GetSize(); i++)
		{
			str = pSA->GetAt(i);
			if(str.CompareNoCase("indent") == 0)
				c_checkIndent.SetCheck(1);
			else if(str.CompareNoCase("outdent") == 0)
				c_checkOutdent.SetCheck(1);
		}

		c_listLuaKeywords.SetCurSel(0);
	}
	else
	{
		c_buttonRemoveLuaKeyword.EnableWindow(FALSE);
	}

	// FEMM Lua functions.

	// Add extended style to highlight entire row of list control.
	c_listFEMMLuaFunctions.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	c_listFEMMLuaFunctions.InsertColumn(0, "Function", LVCFMT_LEFT, 110);
	for(i=1; i<=::g_FEMMLuaFunctions.GetMaxParams(); i++)
	{
		CString str;
		str.Format("P%i", i);
		c_listFEMMLuaFunctions.InsertColumn(i, str, LVCFMT_CENTER, 65);
	}
	if(::g_FEMMLuaFunctions.GetSize() > 0)
	{
		for(int j=0; j<::g_FEMMLuaFunctions.GetSize(); j++)
		{
			pSA = (CStringArray*)::g_FEMMLuaFunctions.GetAt(j);
			AddToFEMMLuaFunctionsListCtrl(pSA, j);
		}
		
		c_listFEMMLuaFunctions.SetItemState(0, LVIS_SELECTED | LVIS_FOCUSED, \
			LVIS_SELECTED | LVIS_FOCUSED);
		c_listFEMMLuaFunctions.EnsureVisible(0, FALSE);
	}
	else
	{
		c_buttonEditFEMMLuaFunction.EnableWindow(FALSE);
		c_buttonRemoveFEMMLuaFunction.EnableWindow(FALSE);
	}
	c_listFEMMLuaFunctions.RedrawItems(0,8);

	// Add ToolTip.
	m_ttPreferencesToolTip.Create(this);
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_CHECKAUTOCOMPLETION), \
		MAKEINTRESOURCE(IDSTT_AUTOCOMPLETION));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_CHECKINTELLITIP), \
		MAKEINTRESOURCE(IDSTT_INTELLITIP));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_CHECKAUTOINDENTATION), \
		MAKEINTRESOURCE(IDSTT_AUTOINDENTATION));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_CHECKSYNTAXHIGHLIGHTING), \
		MAKEINTRESOURCE(IDSTT_SYNTAXHIGHLIGHTING));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_RADIOTWOSPACES), \
		MAKEINTRESOURCE(IDSTT_INDENTSIZE));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_RADIOFOURSPACES), \
		MAKEINTRESOURCE(IDSTT_INDENTSIZE));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_RADIOTAB), \
		MAKEINTRESOURCE(IDSTT_INDENTSIZE));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_COMBOSTYLES), \
		MAKEINTRESOURCE(IDSTT_STYLES));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_CHECKINDENT), \
		MAKEINTRESOURCE(IDSTT_INDENT));
	m_ttPreferencesToolTip.AddWindowTool(GetDlgItem(IDC_CHECKOUTDENT), \
		MAKEINTRESOURCE(IDSTT_OUTDENT));

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFEMMedPreferencesDlg::OnOK() 
{
	OnApply();
	
	CDialog::OnOK();
}

void CFEMMedPreferencesDlg::OnAutoCompletion() 
{
	c_buttonApply.EnableWindow(TRUE);
}

void CFEMMedPreferencesDlg::OnAutoIndentation() 
{
	if(c_checkAutoIndentation.GetCheck() == 0)
	{
		c_radioTwoSpaces.EnableWindow(FALSE);
		c_radioFourSpaces.EnableWindow(FALSE);
		c_radioTab.EnableWindow(FALSE);
		c_checkIndent.EnableWindow(FALSE);
		c_checkOutdent.EnableWindow(FALSE);
	}
	else
	{
		c_radioTwoSpaces.EnableWindow(TRUE);
		c_radioFourSpaces.EnableWindow(TRUE);
		c_radioTab.EnableWindow(TRUE);
		c_checkIndent.EnableWindow(TRUE);
		c_checkOutdent.EnableWindow(TRUE);
	}
}

void CFEMMedPreferencesDlg::OnIntelliTip() 
{
	c_buttonApply.EnableWindow(TRUE);
}

void CFEMMedPreferencesDlg::OnSyntaxHighlighting() 
{
	c_buttonApply.EnableWindow(TRUE);

	if(c_checkSyntaxHighlighting.GetCheck() == 0)
	{
		c_comboStyles.EnableWindow(FALSE);
		c_richeditColor.SetBackgroundColor(FALSE, RGB(196, 196, 196));
		c_buttonColor.EnableWindow(FALSE);
		c_checkBold.EnableWindow(FALSE);
		c_checkItalic.EnableWindow(FALSE);
		c_checkUnderline.EnableWindow(FALSE);
		c_sampleText.EnableWindow(FALSE);
	}
	else
	{
		c_comboStyles.EnableWindow(TRUE);
		c_richeditColor.SetBackgroundColor(FALSE, m_symStyles[c_comboStyles.GetCurSel()].GetColor());
		c_buttonColor.EnableWindow(TRUE);
		c_checkBold.EnableWindow(TRUE);
		c_checkItalic.EnableWindow(TRUE);
		c_checkUnderline.EnableWindow(TRUE);
		c_sampleText.EnableWindow(TRUE);
	}
}

void CFEMMedPreferencesDlg::OnApply() 
{
	BOOL bFormatAllViews = FALSE;

	// Check if there have been any changes to the feature options.
	if(::g_bAutoCompletion != c_checkAutoCompletion.GetCheck())
	{
		::g_bAutoCompletion = c_checkAutoCompletion.GetCheck();
		bFormatAllViews = TRUE;
	}
	if(::g_bAutoIndentation != c_checkAutoIndentation.GetCheck())
	{
		::g_bAutoIndentation = c_checkAutoIndentation.GetCheck();
		//bFormatAllViews = TRUE;
	}
	if(::g_bIntelliTip != c_checkIntelliTip.GetCheck())
	{
		::g_bIntelliTip = c_checkIntelliTip.GetCheck();
		bFormatAllViews = TRUE;
	}
	if(::g_bSyntaxHighlighting != c_checkSyntaxHighlighting.GetCheck())
	{
		::g_bSyntaxHighlighting = c_checkSyntaxHighlighting.GetCheck();
		bFormatAllViews = TRUE;
	}
	if(c_radioTwoSpaces.GetCheck())
	{
		::g_enumIndent = ::TWOSPACES;
	}
	else if(c_radioFourSpaces.GetCheck())
	{
		::g_enumIndent = ::FOURSPACES;
	}
	else  // else if(c_radioTab.GetCheck())
	{
		::g_enumIndent = ::TAB;
	}

	// Check if there have been any changes to the symbol styles.
	if(::g_symComment != m_symStyles[0])
	{
		::g_symComment = m_symStyles[0];
		bFormatAllViews = TRUE;
	}
	if(::g_symFunction != m_symStyles[1])
	{
		::g_symFunction = m_symStyles[1];
		bFormatAllViews = TRUE;
	}
	if(::g_symKeyword != m_symStyles[2])
	{
		::g_symKeyword = m_symStyles[2];
		bFormatAllViews = TRUE;
	}
	if(::g_symNumber != m_symStyles[3])
	{
		::g_symNumber = m_symStyles[3];
		bFormatAllViews = TRUE;
	}
	if(::g_symPunctuation != m_symStyles[4])
	{
		::g_symPunctuation = m_symStyles[4];
		bFormatAllViews = TRUE;
	}
	if(::g_symString != m_symStyles[5])
	{
		::g_symString = m_symStyles[5];
		bFormatAllViews = TRUE;
	}

	if(m_bLuaKeywordsChanged || m_bFEMMLuaFunctionsChanged)
		bFormatAllViews = TRUE;

	// If there have been any changes format all views.
	if(bFormatAllViews)
	{
		((CFEMMedApp*)AfxGetApp())->FormatAllViews();
	}

	// Finally, reset the apply button.
	c_buttonApply.EnableWindow(FALSE);
}

// When combo selecton changed, update style controls.
void CFEMMedPreferencesDlg::OnSelchangeComboStyles() 
{
	int i = c_comboStyles.GetCurSel();

	c_richeditColor.SetBackgroundColor(FALSE, m_symStyles[i].GetColor());
	c_sampleText.SetTextColor(m_symStyles[i].GetColor());
	c_checkBold.SetCheck(m_symStyles[i].GetBold());
	c_sampleText.SetFontBold(m_symStyles[i].GetBold());
	c_checkItalic.SetCheck(m_symStyles[i].GetItalic());
	c_sampleText.SetFontItalic(m_symStyles[i].GetItalic());
	c_checkUnderline.SetCheck(m_symStyles[i].GetUnderline());
	c_sampleText.SetFontUnderline(m_symStyles[i].GetUnderline());
}

// Create common color picker dialog.
void CFEMMedPreferencesDlg::OnColor() 
{
	CColorDialog colorDlg;
	colorDlg.m_cc.Flags |= CC_RGBINIT | CC_FULLOPEN;
	COLORREF custColors[16] = {
		m_symStyles[0].GetColor(), m_symStyles[1].GetColor(),
		m_symStyles[2].GetColor(), m_symStyles[3].GetColor(),
		m_symStyles[4].GetColor(), m_symStyles[5].GetColor(), RGB(255,255,255),
		RGB(255,255,255), RGB(255,255,255), RGB(255,255,255), RGB(255,255,255),
		RGB(255,255,255), RGB(255,255,255), RGB(255,255,255), RGB(255,255,255),
		RGB(255,255,255)
	};
	colorDlg.m_cc.lpCustColors = custColors;

	int i = c_comboStyles.GetCurSel();
	colorDlg.m_cc.rgbResult = m_symStyles[i].GetColor();

	if(colorDlg.DoModal() == IDOK)
	{
		m_symStyles[i].SetColor(colorDlg.GetColor());
		c_richeditColor.SetBackgroundColor(FALSE, m_symStyles[i].GetColor());

		c_sampleText.SetTextColor(colorDlg.GetColor());

		c_buttonApply.EnableWindow(TRUE);
	}
}

void CFEMMedPreferencesDlg::OnBold() 
{
	m_symStyles[c_comboStyles.GetCurSel()].SetBold(c_checkBold.GetCheck());

	c_buttonApply.EnableWindow(TRUE);
	
	c_sampleText.SetFontBold(c_checkBold.GetCheck());
}

void CFEMMedPreferencesDlg::OnItalic() 
{
	m_symStyles[c_comboStyles.GetCurSel()].SetItalic(c_checkItalic.GetCheck());

	c_buttonApply.EnableWindow(TRUE);
	
	c_sampleText.SetFontItalic(c_checkItalic.GetCheck());
}

void CFEMMedPreferencesDlg::OnUnderline() 
{
	m_symStyles[c_comboStyles.GetCurSel()].SetUnderline(c_checkUnderline.GetCheck());

	c_buttonApply.EnableWindow(TRUE);
	
	c_sampleText.SetFontUnderline(c_checkUnderline.GetCheck());
}

void CFEMMedPreferencesDlg::OnSelChangeListKeywords() 
{
	// Reset checks.
	c_checkIndent.SetCheck(0);
	c_checkOutdent.SetCheck(0);

	int nCurSel = c_listLuaKeywords.GetCurSel();
	CStringArray* pSA = (CStringArray*)::g_LuaKeywords.GetAt(nCurSel);
	CString str;
	for(int i=1; i<pSA->GetSize(); i++)
	{
		str = pSA->GetAt(i);
		if(str.CompareNoCase("indent") == 0)
			c_checkIndent.SetCheck(1);
		else if(str.CompareNoCase("outdent") == 0)
			c_checkOutdent.SetCheck(1);
	}
}

void CFEMMedPreferencesDlg::OnAddLuaKeyword() 
{
	CString str;
	int nLen = c_editLuaKeyword.GetWindowText(str.GetBuffer(256), 256);
	str.ReleaseBuffer(nLen);

	// Check it doesn't exist already.
	for(int i=0 ; i<::g_LuaKeywords.GetSize() ; i++)
	{
		CStringArray* pSA = (CStringArray*)::g_LuaKeywords.GetAt(i);
		if((pSA->GetAt(0)).Compare(str) == 0)
		{
			MessageBox("\"" + str + "\"" + " already defined as keyword!", \
				"FEMMed - Duplicate entry!", MB_ICONWARNING | MB_OK);
			c_editLuaKeyword.SetFocus();
			c_editLuaKeyword.SetSel(0, -1);
			return;
		}
	}

	// Lua keywords cannot begin with a number.
	if(str.FindOneOf("01234567890") == 0)
	{
		MessageBox("Lua keyword cannot begin with a number", "FEMMed - Error!", \
			MB_ICONWARNING | MB_OK);
		c_editLuaKeyword.SetFocus();
		c_editLuaKeyword.SetSel(0, -1);
		return;
	}

	::g_LuaKeywords.Add(new CStringArray);
	((CStringArray*)::g_LuaKeywords.GetAt(::g_LuaKeywords.GetUpperBound()))->Add(str);
	::g_LuaKeywords.Sort();
	c_listLuaKeywords.AddString(str);
	c_listLuaKeywords.SetCurSel(c_listLuaKeywords.FindStringExact(1, str));
	c_editLuaKeyword.SetWindowText("");
	c_editLuaKeyword.SetFocus();
	c_checkIndent.SetCheck(0);
	c_checkOutdent.SetCheck(0);
	m_bLuaKeywordsChanged = TRUE;
	c_buttonRemoveLuaKeyword.EnableWindow(TRUE);
	c_buttonApply.EnableWindow(TRUE);

	if(!c_checkIndent.IsWindowEnabled() && !c_checkOutdent.IsWindowEnabled())
	{
		c_checkIndent.EnableWindow(TRUE);
		c_checkOutdent.EnableWindow(TRUE);
	}
}

void CFEMMedPreferencesDlg::OnChangeEditLuaKeyword() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// Respond to key presses in the edit control.
	CString str;
	int nLen = c_editLuaKeyword.GetWindowText(str.GetBuffer(4), 4);
	str.ReleaseBuffer(nLen);

	if(str.GetLength() == 0)
		c_buttonAddLuaKeyword.EnableWindow(FALSE);
	else
		c_buttonAddLuaKeyword.EnableWindow(TRUE);
}

void CFEMMedPreferencesDlg::OnRemoveLuaKeyword() 
{
	if(c_listLuaKeywords.GetCurSel() == LB_ERR)
		return;

	int nItem = c_listLuaKeywords.GetCurSel();
	if(nItem >= 0)
	{
		if(MessageBox("Are you sure you\nwant to remove: \"" + \
			((CStringArray*)::g_LuaKeywords.GetAt(nItem))->GetAt(0) + "\"", \
			"FEMMed - Remove keyword?", MB_ICONWARNING | MB_YESNO) == IDYES)
		{
			::g_LuaKeywords.RemoveAt(nItem);
			c_listLuaKeywords.DeleteString(nItem);
			if(c_listLuaKeywords.GetCount() > 0)
			{
				if(c_listLuaKeywords.GetCount() > nItem)
				{
					c_listLuaKeywords.SetCurSel(nItem);
					SendMessage(WM_COMMAND, (WPARAM)MAKELONG(c_listLuaKeywords.GetDlgCtrlID(), \
						LBN_SELCHANGE), (LPARAM)c_listLuaKeywords.GetSafeHwnd());
				}
				else
				{
					c_listLuaKeywords.SetCurSel(nItem-1);
					SendMessage(WM_COMMAND, (WPARAM)MAKELONG(c_listLuaKeywords.GetDlgCtrlID(), \
						LBN_SELCHANGE), (LPARAM)c_listLuaKeywords.GetSafeHwnd());
				}
			}
			else
			{
				c_checkIndent.SetCheck(0);
				c_checkOutdent.SetCheck(0);
				c_checkIndent.EnableWindow(FALSE);
				c_checkOutdent.EnableWindow(FALSE);
				c_buttonRemoveLuaKeyword.EnableWindow(FALSE);
			}
			m_bLuaKeywordsChanged = TRUE;
			c_buttonApply.EnableWindow(TRUE);
		}
	}
}

void CFEMMedPreferencesDlg::OnIndent() 
{
	if(c_listLuaKeywords.GetCurSel() == LB_ERR)
		return;

	BOOL bIndent = FALSE;
	CStringArray* pSA = (CStringArray*)::g_LuaKeywords.GetAt(c_listLuaKeywords.GetCurSel());
	for(int i=1; i<pSA->GetSize(); i++)
	{
		if(pSA->GetAt(i).CompareNoCase("indent") == 0)
		{
			bIndent = TRUE;
			break;
		}
	}

	int nChecked = c_checkIndent.GetCheck();

	if(!bIndent && nChecked == 1)
		pSA->Add("indent");
	else if(bIndent && nChecked == 0)
		pSA->RemoveAt(i);
}

void CFEMMedPreferencesDlg::OnOutdent() 
{
	if(c_listLuaKeywords.GetCurSel() == LB_ERR)
		return;

	BOOL bOutdent = FALSE;
	CStringArray* pSA = (CStringArray*)::g_LuaKeywords.GetAt(c_listLuaKeywords.GetCurSel());
	for(int i=1; i<pSA->GetSize(); i++)
	{
		if(pSA->GetAt(i).CompareNoCase("outdent") == 0)
		{
			bOutdent = TRUE;
			break;
		}
	}

	int nChecked = c_checkIndent.GetCheck();

	if(!bOutdent && nChecked == 1)
		pSA->Add("outdent");
	else if(bOutdent && nChecked == 0)
		pSA->RemoveAt(i);
}

BOOL CFEMMedPreferencesDlg::PreTranslateMessage(MSG* pMsg) 
{
	// Lua identifiers can contain only contains letters, digits, and underscores.
	if(pMsg->hwnd == c_editLuaKeyword.GetSafeHwnd() && pMsg->message == WM_CHAR)
	{
		if((!isalpha(pMsg->wParam) && !isdigit(pMsg->wParam)) && pMsg->wParam != VK_BACK
			&& pMsg->wParam != '_')
			return TRUE;  // Don't dispatch message.
		if(pMsg->wParam == VK_RETURN)
			OnAddLuaKeyword();
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CFEMMedPreferencesDlg::OnAddFEMMLuaFunction() 
{
	CStringArray* pSA = new CStringArray;
	int* pnDelta = new int;
	*pnDelta = 0;

	CFEMMedAddEditFunctionDlg addFunctionDlg;
	addFunctionDlg.m_pSA = pSA;
	addFunctionDlg.m_pnDelta = pnDelta;
	if(addFunctionDlg.DoModal() == IDOK)
	{
		int nItem = c_listFEMMLuaFunctions.GetItemCount();
		AddToFEMMLuaFunctionsListCtrl(pSA, nItem);

		c_listFEMMLuaFunctions.SetItemState(nItem, LVIS_SELECTED | LVIS_FOCUSED, \
			LVIS_SELECTED | LVIS_FOCUSED);

		// Sort the list control.
		c_listFEMMLuaFunctions.SortItems(CompareFunc, (LPARAM)&c_listFEMMLuaFunctions);

		// Scroll if necessary. Need to find the item added after data has been sorted.
		for(int i=0; i<c_listFEMMLuaFunctions.GetItemCount(); i++)
		{
			if(nItem == (int)c_listFEMMLuaFunctions.GetItemData(i))
			{
				nItem = i;
				break;
			}
		}
		c_listFEMMLuaFunctions.EnsureVisible(nItem, FALSE);
		int nTop = c_listFEMMLuaFunctions.GetTopIndex();
		c_listFEMMLuaFunctions.RedrawItems(nTop, nTop + 8);
		c_buttonEditFEMMLuaFunction.EnableWindow(TRUE);
		c_buttonRemoveFEMMLuaFunction.EnableWindow(TRUE);
		
		// Add to global data.
		::g_FEMMLuaFunctions.Add(pSA);
		::g_FEMMLuaFunctions.Sort();
	}
	else
	{
		delete pSA;
	}
	
	delete pnDelta;
}

void CFEMMedPreferencesDlg::OnEditFEMMLuaFunction() 
{
	POSITION pos = c_listFEMMLuaFunctions.GetFirstSelectedItemPosition();
	
	if(pos == NULL)
	{
		MessageBox("No selection!", "FEMMed - Error!", MB_OK);
		return;
	}

	int nItem = c_listFEMMLuaFunctions.GetNextSelectedItem(pos);

	CStringArray* pSA = new CStringArray;
	pSA->Copy(*((CStringArray*)::g_FEMMLuaFunctions.GetAt(nItem)));
	int* pnDelta = new int;
	*pnDelta = 0;

	CFEMMedAddEditFunctionDlg addFunctionDlg;
	addFunctionDlg.m_pSA = pSA;
	addFunctionDlg.m_pnDelta = pnDelta;
	if(addFunctionDlg.DoModal() == IDOK)
	{
		RemoveFromFEMMLuaFunctionsListCtrl(pSA, nItem, *pnDelta);
		AddToFEMMLuaFunctionsListCtrl(pSA, nItem);

		c_listFEMMLuaFunctions.SetItemState(nItem, LVIS_SELECTED | LVIS_FOCUSED, \
			LVIS_SELECTED | LVIS_FOCUSED);

		// Sort the list control.
		c_listFEMMLuaFunctions.SortItems(CompareFunc, (LPARAM)&c_listFEMMLuaFunctions);

		// Scroll if necessary. Need to find the item added after data has been sorted.
		for(int i=0; i<c_listFEMMLuaFunctions.GetItemCount(); i++)
		{
			if(nItem == (int)c_listFEMMLuaFunctions.GetItemData(i))
			{
				nItem = i;
				break;
			}
		}
		c_listFEMMLuaFunctions.EnsureVisible(nItem, FALSE);
		int nTop = c_listFEMMLuaFunctions.GetTopIndex();
		c_listFEMMLuaFunctions.RedrawItems(nTop, nTop + 8);
		c_buttonEditFEMMLuaFunction.EnableWindow(TRUE);
		c_buttonRemoveFEMMLuaFunction.EnableWindow(TRUE);
		
		// Add to global data.
		::g_FEMMLuaFunctions.Add(pSA);
		::g_FEMMLuaFunctions.Sort();
	}
	else
	{
		delete pSA;
	}

	delete pnDelta;
}

void CFEMMedPreferencesDlg::OnRemoveFEMMLuaFunction() 
{
	POSITION pos = c_listFEMMLuaFunctions.GetFirstSelectedItemPosition();

	if(pos == NULL)
	{
		MessageBox("No selection!", "FEMMed - Error!", MB_OK);
		return;
	}

	int nItem = c_listFEMMLuaFunctions.GetNextSelectedItem(pos);

	CStringArray* pSA = (CStringArray*)::g_FEMMLuaFunctions.GetAt(nItem);

	if(MessageBox("Are you sure you\nwant to remove: \"" + pSA->GetAt(0) + "\"", \
		"FEMMed - Remove keyword?", MB_ICONWARNING | MB_YESNO) == IDYES)
	{
		RemoveFromFEMMLuaFunctionsListCtrl(pSA, nItem);

		int nCount = c_listFEMMLuaFunctions.GetItemCount();
		if(nCount > nItem)
		{
			c_listFEMMLuaFunctions.SetItemState(nItem, LVIS_SELECTED | LVIS_FOCUSED, \
				LVIS_SELECTED | LVIS_FOCUSED);
			int nTop = c_listFEMMLuaFunctions.GetTopIndex();
			c_listFEMMLuaFunctions.RedrawItems(nTop, nTop + 8);
		}
		else if(nCount > 0)
		{
			
			c_listFEMMLuaFunctions.SetItemState(nCount-1, LVIS_SELECTED | LVIS_FOCUSED, \
				LVIS_SELECTED | LVIS_FOCUSED);
			int nTop = c_listFEMMLuaFunctions.GetTopIndex();
			c_listFEMMLuaFunctions.RedrawItems(nTop, nTop + 8);
		}
		else
		{
			c_buttonEditFEMMLuaFunction.EnableWindow(FALSE);
			c_buttonRemoveFEMMLuaFunction.EnableWindow(FALSE);
		}
	}
}

int CALLBACK CFEMMedPreferencesDlg::CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	// lParamSort contains a pointer to the list view control.
	// The lParam of an item is just its index.
	CListCtrl* pListCtrl = (CListCtrl*) lParamSort;
	CString str1 = pListCtrl->GetItemText(lParam1, 0);
	CString str2 = pListCtrl->GetItemText(lParam2, 0);

	return lstrcmp(str1, str2);
}

void CFEMMedPreferencesDlg::AddToFEMMLuaFunctionsListCtrl(CStringArray* pSA, int nItem)
{
	// Insert new column if required.
	int nParams = pSA->GetSize() - 1;
	int nStart = ::g_FEMMLuaFunctions.GetMaxParams() + 1;

	for(int i=nStart; i<=nParams; i++)
	{
		CString str;
		str.Format("P%i", i);
		c_listFEMMLuaFunctions.InsertColumn(i, str, LVCFMT_CENTER, 65);
	}

	// Add data to list control.
	c_listFEMMLuaFunctions.InsertItem(nItem, pSA->GetAt(0));
	c_listFEMMLuaFunctions.SetItemData(nItem, nItem);
	for(i=1; i<pSA->GetSize(); i++)
	{
		c_listFEMMLuaFunctions.SetItemText(nItem, i, pSA->GetAt(i));
	}
}

void CFEMMedPreferencesDlg::RemoveFromFEMMLuaFunctionsListCtrl(CStringArray* pSA, int nItem, int nDelta)
{
	// Remove end column if required.
	int nCols = pSA->GetSize() - nDelta - 1;

	// Delete global data.
	delete ::g_FEMMLuaFunctions.GetAt(nItem);
	::g_FEMMLuaFunctions.RemoveAt(nItem);

	for(int i=nCols; i>::g_FEMMLuaFunctions.GetMaxParams(); i--)
	{
		if(i > 0)
		{
			c_listFEMMLuaFunctions.DeleteColumn(i);
		}
	}

	c_listFEMMLuaFunctions.DeleteItem(nItem);
}
