#if !defined(AFX_FEMMEDPREFERENCESDLG_H__F924FAC2_8C4D_40F6_88A6_496977C30498__INCLUDED_)
#define AFX_FEMMEDPREFERENCESDLG_H__F924FAC2_8C4D_40F6_88A6_496977C30498__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FEMMedPreferencesDlg.h : header file
//

#include "SampleText.h"
#include "SymbolStyle.h"
#include "FEMMedToolTip.h"

/////////////////////////////////////////////////////////////////////////////
// CFEMMedPreferencesDlg dialog

class CFEMMedPreferencesDlg : public CDialog
{
// Construction
public:
	CFEMMedPreferencesDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CFEMMedPreferencesDlg)
	enum { IDD = IDD_PREFERENCES };
	CButton	c_buttonEditFEMMLuaFunction;
	CButton	c_buttonAddFEMMLuaFunction;
	CButton	c_buttonRemoveFEMMLuaFunction;
	CEdit	c_editLuaKeyword;
	CButton	c_buttonRemoveLuaKeyword;
	CButton	c_buttonAddLuaKeyword;
	CListBox	c_listLuaKeywords;
	CListCtrl	c_listFEMMLuaFunctions;
	CButton	c_checkIndent;
	CButton	c_checkOutdent;
	CComboBox	c_comboStyles;
	CSampleText	c_sampleText;
	CRichEditCtrl	c_richeditColor;
	CButton	c_checkItalic;
	CButton	c_checkUnderline;
	CButton	c_checkBold;
	CButton	c_buttonColor;
	CButton	c_checkIntelliTip;
	CButton	c_buttonApply;
	CButton	c_radioFourSpaces;
	CButton	c_radioTab;
	CButton	c_radioTwoSpaces;
	CButton	c_checkSyntaxHighlighting;
	CButton	c_checkAutoIndentation;
	CButton	c_checkAutoCompletion;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFEMMedPreferencesDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CFEMMedPreferencesDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnApply();
	afx_msg void OnAutoCompletion();
	afx_msg void OnAutoIndentation();
	afx_msg void OnIntelliTip();
	afx_msg void OnSyntaxHighlighting();
	afx_msg void OnSelchangeComboStyles();
	afx_msg void OnColor();
	afx_msg void OnBold();
	afx_msg void OnItalic();
	afx_msg void OnUnderline();
	afx_msg void OnSelChangeListKeywords();
	afx_msg void OnAddLuaKeyword();
	afx_msg void OnChangeEditLuaKeyword();
	afx_msg void OnRemoveLuaKeyword();
	afx_msg void OnIndent();
	afx_msg void OnOutdent();
	afx_msg void OnAddFEMMLuaFunction();
	afx_msg void OnEditFEMMLuaFunction();
	afx_msg void OnRemoveFEMMLuaFunction();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	// [0] = comment style.      [1] = function style.
	// [2] = keyword style.      [3] = number style.
	// [4] = punctuation style.  [5] = string style.
	CSymbolStyle m_symStyles[6];

	BOOL m_bLuaKeywordsChanged;
	BOOL m_bFEMMLuaFunctionsChanged;

	CFEMMedToolTip m_ttPreferencesToolTip;
	static int CALLBACK CompareFunc(LPARAM, LPARAM, LPARAM);
	void AddToFEMMLuaFunctionsListCtrl(CStringArray* pSA, int nItem);
	void RemoveFromFEMMLuaFunctionsListCtrl(CStringArray* pSA, int nItem) \
		{ RemoveFromFEMMLuaFunctionsListCtrl(pSA, nItem, 0); }
	void RemoveFromFEMMLuaFunctionsListCtrl(CStringArray* pSA, int nItem, int nDelta);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FEMMEDPREFERENCESDLG_H__F924FAC2_8C4D_40F6_88A6_496977C30498__INCLUDED_)
