// IntelliTip.cpp : implementation file
//

#include "stdafx.h"
#include "FEMMed.h"
#include "IntelliTip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIntelliTip dialog

CIntelliTip::CIntelliTip(CWnd* pParent /*=NULL*/)
	: CDialog(CIntelliTip::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIntelliTip)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bIsShown = FALSE;
}

void CIntelliTip::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIntelliTip)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIntelliTip, CDialog)
	//{{AFX_MSG_MAP(CIntelliTip)
	ON_WM_PAINT()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIntelliTip message handlers

void CIntelliTip::Show()
{
	if(!IsShown())
	{
		m_bIsShown = TRUE;
		ShowWindow(SW_SHOW);
	}
}

void CIntelliTip::Hide()
{
	if(IsShown())
	{
		ShowWindow(SW_HIDE);
		m_bIsShown = FALSE;
	}
}

void CIntelliTip::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CRect rect;
	GetClientRect(&rect);
	dc.SetBkMode(TRANSPARENT);

	dc.FillRect(&rect,&CBrush(RGB(255,255,200)));

	CRect textRect(rect);
	textRect.DeflateRect(5,0);

	int curText = 0;

	if (curText == m_nCurParam)
		dc.SelectObject(m_fontBold);
	else
		dc.SelectObject(m_fontReg);
	CString str = m_strFName;
	dc.TextOut(textRect.left,textRect.top,str);
	CSize sz = dc.GetTextExtent(str);
	textRect.left += sz.cx;
	curText++;

	dc.SelectObject(m_fontReg);

	dc.TextOut(textRect.left,textRect.top,"(");
	sz = dc.GetTextExtent("(");
	textRect.left += sz.cx;

	CSize spsz = dc.GetTextExtent(", ");

	for (int i = 0; i < m_strArrFParams.GetSize(); i++)
	{
		str = m_strArrFParams[i];
		if (curText == m_nCurParam)
			dc.SelectObject(m_fontBold);
		else
			dc.SelectObject(m_fontReg);
		dc.TextOut(textRect.left,textRect.top,str);
		sz = dc.GetTextExtent(str);
		textRect.left += sz.cx;
		dc.SelectObject(m_fontReg);
		if (i < m_strArrFParams.GetSize()-1)
		{
			dc.TextOut(textRect.left,textRect.top,", ");
			textRect.left += spsz.cx;
		}
		curText++;
	}
	dc.TextOut(textRect.left,textRect.top,")");

	dc.FrameRect(&rect,&CBrush(RGB(0,0,0)));
	// Do not call CDialog::OnPaint() for painting messages
}

void CIntelliTip::SetFunction(const CString fName, const CStringArray& params)
{
	m_strFName = fName;
	m_strArrFParams.RemoveAll();
	for (int i = 0 ; i < params.GetSize(); i++)
		m_strArrFParams.Add(params[i]);
	UpdatePosition();
}

void CIntelliTip::SetCurParam(const int cp)
{
	m_nCurParam = cp;
	Invalidate();
}

void CIntelliTip::SetCursorPoint(CPoint pt)
{
	m_pParent->ClientToScreen(&pt);
	m_pt = pt;
	UpdatePosition();
}

BOOL CIntelliTip::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Initialize fonts.
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));             // Zero out structure.
	lf.lfHeight = 15;                            // Request a 12-pixel-height font.
	strcpy(lf.lfFaceName, "Arial");              // Request a face name "Arial".
	VERIFY(m_fontReg.CreateFontIndirect(&lf));   // Create the regular font.
	lf.lfWeight = FW_BOLD;
	VERIFY(m_fontBold.CreateFontIndirect(&lf));  // Create the bold font.
	GetDC()->SelectObject(m_fontReg);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CIntelliTip::OnSetFocus(CWnd* pOldWnd) 
{
	// CDialog::OnSetFocus(pOldWnd);

	if (pOldWnd)
		pOldWnd->SetFocus();
}

void CIntelliTip::UpdatePosition()
{
	CString str = m_strFName;
	str += "(";
	for (int i = 0 ; i < m_strArrFParams.GetSize(); i++)
	{
		str += m_strArrFParams[i];
		if (i < m_strArrFParams.GetSize()-1)
			str += ", ";
	}
	str += ")";

	CDC *pDc = GetDC();
	pDc->SelectObject(m_fontReg);
	CSize sz = pDc->GetTextExtent(str);

	CRect rcWnd;
	m_pParent->GetClientRect(&rcWnd);
	m_pParent->ScreenToClient(&m_pt);

	if(m_pt.x + sz.cx+8 > rcWnd.right)
		m_pt.x -= (m_pt.x + sz.cx+12 - rcWnd.right);
	else
		m_pt.x += 8;

	if(m_pt.y + sz.cy+2 + 20 > rcWnd.bottom)
		m_pt.y -= 20;
	else
		m_pt.y += 20;

	MoveWindow(m_pt.x, m_pt.y, sz.cx+10, sz.cy+2);

	Invalidate();
}

BOOL CIntelliTip::Create(CWnd *pParent)
{
	m_pParent = pParent;
	return CDialog::Create(IDD_ITOOLTIP, pParent);
}
