/////////////////////////////////////////////////////////////////////////////
// Class for Pop-Up smart ToolTip.
// Derived from simple dialog window.
// http://www.codeproject.com/miscctrl/intellitip.asp
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTELLITIP_H__E4FC2226_82ED_4C26_9B88_A7016ED0BC87__INCLUDED_)
#define AFX_INTELLITIP_H__E4FC2226_82ED_4C26_9B88_A7016ED0BC87__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IntelliTip.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CIntelliTip dialog

class CIntelliTip : public CDialog
{
public:
	// Construction
	CIntelliTip(CWnd* pParent = NULL);   // standard constructor
	BOOL Create(CWnd *pParent);

	// Helper functons 
	int GetNumParams() { return m_strArrFParams.GetSize(); }
	int GetCurParam() { return m_nCurParam; }
	CString GetFunction() { return m_strFName; }
	void SetCursorPoint(CPoint);                           // Update position.
	void SetCurParam(const int);                           // Change the parameter that is bold.
	void SetFunction(const CString, const CStringArray&);  // Set the data for ToolTip.
	void Hide();
	void Show();
	BOOL IsShown() { return m_bIsShown; }
	
	// Dialog Data
	//{{AFX_DATA(CIntelliTip)
	enum { IDD = IDD_ITOOLTIP };
	// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIntelliTip)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Generated message map functions
	//{{AFX_MSG(CIntelliTip)
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CWnd* m_pParent;
	void UpdatePosition(); 
	CFont m_fontReg, m_fontBold;  // Normal and bold fonts for the ToolTip.
	CPoint m_pt;                  // TopLeft corner.
	int m_nCurParam;              // The current parameter (highlighted bold).
	CStringArray m_strArrFParams;
	CString m_strFName;
	BOOL m_bIsShown;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INTELLITIP_H__E4FC2226_82ED_4C26_9B88_A7016ED0BC87__INCLUDED_)