// SampleText.cpp : implementation file
//

#include "stdafx.h"
#include "FEMMed.h"
#include "SampleText.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleText

CSampleText::CSampleText()
{
	m_hBrush = ::CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	
	::GetObject((HFONT)GetStockObject(DEFAULT_GUI_FONT),sizeof(m_lf),&m_lf);
	m_font.CreateFontIndirect(&m_lf);
}

CSampleText::~CSampleText()
{
	m_font.DeleteObject();
}

CSampleText& CSampleText::SetFontName(const CString& strFont)
{
	strcpy(m_lf.lfFaceName,strFont);
	ReconstructFont();
	RedrawWindow();
	return *this;
}

CSampleText& CSampleText::SetFontSize(int nSize)
{
	nSize*=-1;
	m_lf.lfHeight = nSize;
	ReconstructFont();
	RedrawWindow();
	return *this;
}

CSampleText& CSampleText::SetTextColor(COLORREF crText)
{
	m_crText = crText;
	RedrawWindow();
	return *this;
}

CSampleText& CSampleText::SetFontBold(BOOL bBold)
{
	m_lf.lfWeight = bBold ? FW_BOLD : FW_NORMAL;
	ReconstructFont();
	RedrawWindow();
	return *this;
}

CSampleText& CSampleText::SetFontItalic(BOOL bItalic)
{
	m_lf.lfItalic = bItalic;
	ReconstructFont();
	RedrawWindow();
	return *this;	
}

CSampleText& CSampleText::SetFontUnderline(BOOL bUnderline)
{	
	m_lf.lfUnderline = bUnderline;
	ReconstructFont();
	RedrawWindow();
	return *this;
}

void CSampleText::ReconstructFont()
{
	m_font.DeleteObject();
	BOOL bCreated = m_font.CreateFontIndirect(&m_lf);

	ASSERT(bCreated);
}

BEGIN_MESSAGE_MAP(CSampleText, CStatic)
	//{{AFX_MSG_MAP(CSampleText)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleText message handlers

HBRUSH CSampleText::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	// TODO: Change any attributes of the DC here
	if (CTLCOLOR_STATIC == nCtlColor)
	{
		pDC->SelectObject(&m_font);
		pDC->SetTextColor(m_crText);
		pDC->SetBkMode(TRANSPARENT);
	}
	
	// TODO: Return a non-NULL brush if the parent's handler should not be called
	return m_hBrush;
}
